"use strict";
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const jsonPtr = __importStar(require("json-ptr"));
function resolveRefPriv(document, ref) {
    if (!ref.startsWith('#/') && !ref.startsWith('/') && ref !== '') {
        throw new Error(`Cannot resolve non-local ref ${ref}`);
    }
    const path = jsonPtr.decode(ref);
    let currentDoc = document;
    while (path.length > 0) {
        const pathname = path.shift();
        currentDoc = currentDoc && currentDoc[pathname];
        while (currentDoc && currentDoc.$ref) {
            currentDoc = resolveRefPriv(document, currentDoc.$ref);
        }
    }
    return currentDoc;
}
function resolveRef(document, ref) {
    if (ref instanceof String) {
        return resolveRef(document, ref.toString());
    }
    else if (typeof ref === 'string') {
        return resolveRefPriv(document, ref);
    }
    else if (ref.$ref) {
        return resolveRefPriv(document, ref.$ref);
    }
    else {
        return ref;
    }
}
exports.resolveRef = resolveRef;
//# sourceMappingURL=json-schema-resolve-ref.js.map