"use strict";
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const jsonPtr = __importStar(require("json-ptr"));
function normalize(path) {
    return jsonPtr.encodePointer(jsonPtr.decode(path));
}
function toUriFragment(path) {
    return jsonPtr.encodeUriFragmentIdentifier(jsonPtr.decode(path));
}
exports.toUriFragment = toUriFragment;
function jsonPointerStartsWith(path, prefix) {
    path = normalize(path);
    prefix = normalize(prefix);
    return path.startsWith(prefix);
}
exports.jsonPointerStartsWith = jsonPointerStartsWith;
function jsonPointerStripPrefix(path, prefix) {
    const isUriFragment = path.startsWith('#');
    path = normalize(path);
    prefix = normalize(prefix);
    if (path.startsWith(prefix)) {
        const answer = path.slice(prefix.length);
        if (isUriFragment) {
            return toUriFragment(answer);
        }
        else {
            return answer;
        }
    }
    else {
        return path;
    }
}
exports.jsonPointerStripPrefix = jsonPointerStripPrefix;
//# sourceMappingURL=jsonPaths.js.map